
//#include "Quickdraw.h"
//#include "EventMgr.h"

#define speed 8			/* must be a power of 2 */

int	hpos,					/* ball h position */
	vpos, 					/* ball v position */
	dh = speed,			/* ball delta h */
	dv = 0,				/* ball delta v */
	width = 16,			/* ball width */
	height = 16,		/* ball height */
	ballX,				/* ball slot # */
	ballY;				/* ball slot # */

int	targetH,			/* target h position */
	targetV, 			/* target v position */
	target;
	
int bumper[32][20];		/* slots for bouncers */

int done;		/* true when games over */

long ballTime,
	timer,
	bestTime = 9999;

BitMap offscreen;
long bits[128];


/* Modified to work better under MultiFinder.
   To be precise, it now uses a window, not just the window Mgr port.
   The window centers on screenBits (main screen) */

static init_window()
{
	GrafPtr port;
	WindowPtr wind;
	Rect rect;
	
//	InitGraf(&thePort);
//	InitWindows();

	GetWMgrPort(&port);
	SetPort(port);
	SetRect(&rect, 0, 0, 512, 342);

	wind = NewWindow (nil, &rect, "\p", false, 8, (WindowPtr)-1L, false, 0L);
	MoveWindow(wind, 0, 20, true);
	MoveWindow(wind, (screenBits.bounds.right - 512) /2,
					 (screenBits.bounds.bottom - 322)/2, true);
	ShowWindow(wind);
	SetPort(wind);

	ClipRect(&rect);
	FillRect(&rect, white);
	HideCursor();
}

pascal PlayPongerang()
{
	EventRecord evt;
	register int spot;
	
	done = false;
	
	init_window();
	DrawTitle();
	
	spot = TickCount() % 1000;
	while (spot-- > 0) Random();
	
	InitCursor();
	
	InitBall();
	
	NewGame();
	
	while (!done)
	{
		ballX = hpos/16;		/* round up in current direction */
		ballY = vpos/16;

		spot = bumper[ballX][ballY];

		/* only check events and turns on even slots */
		if (((hpos % 16) == 0) && ((vpos % 16) == 0))
		{
			if (GetOSEvent(-1, &evt ))
			{ // was GetNextEvent
				switch (evt.what)
				{
					case keyDown:
					{
						done = true; break;
					}
					case mouseDown:
					{
						GlobalToLocal(&evt.where);
						NewBumper(evt.where.h, evt.where.v );
					break;
					}
				} /* end switch */
			} /* getnextevent */
		
		
			if (dv < 0)
			{
				if (spot > 0) {dh = -speed; dv = 0;}
				if (spot < 0) {dh =  speed; dv = 0;}
			}
			else if (dv > 0)
			{
				if (spot > 0) {dh =  speed; dv = 0;}
				if (spot < 0) {dh = -speed; dv = 0;}
			}
			else if (dh < 0)
			{
				if (spot > 0) {dh = 0; dv = -speed;}
				if (spot < 0) {dh = 0; dv =  speed;}
			}
			else if (dh > 0)
			{
				if (spot > 0) {dh = 0; dv =  speed;}
				if (spot < 0) {dh = 0; dv = -speed;}
			}
		} /* end of even check */
		
		BallMove();
		
		DrawTime();
		
	} /* main loop */
	
	DisposeWindow(FrontWindow());
}

static BallMove()
{
	Rect r;
	long x, i;
	
	SetRect( &r, targetH, targetV, targetH+16, targetV+16 );
	
	x = TickCount();
	while (x == TickCount() ) {};
	if (vpos < 80) for (i=1; i<256 ; i++ ) {};

	DrawBall();
	hpos += dh;
	vpos += dv;
	
	if ((hpos >= 512) || (hpos < 0)) hpos += (dh = -dh);
	if ((vpos >= 320) || (vpos < 0)) vpos += (dv = -dv);
	
	if ((hpos == targetH) && (vpos == targetV))
	{
		SysBeep( 2 );
		if (target-- > 0)
		{
			NewTarget();
		}
		else
		{
			x = (TickCount() - timer) / 60;
			if (x < bestTime) bestTime = x;
			
			Zoomer( &r, &thePort->portRect );
			NewGame();
			return;
		}
	}
	
	DrawBall();
}

static DrawBall()
{
	Rect r;
	
	SetRect( &r, hpos, vpos, hpos+16, vpos+16 );
	CopyBits( &offscreen, &thePort->portBits, &offscreen.bounds, &r, srcXor, 0 );
}

static DrawBumper( x, y )
int x,y;
{
	Rect r;
	
	PenSize( 2, 2 );
	SetRect( &r, x*16, y*16, x*16+16, y*16+16 );
	EraseRect( &r );
	
	if (bumper[x][y] > 0)
	{
		MoveTo(r.left, r.top);
		Line( 14, 14 );
	}
	if (bumper[x][y] < 0)
	{
		MoveTo(r.left, r.bottom-2);
		Line( 14, -14 );
	}
}

static DrawTarget()
{
	Rect r;
	
	PenNormal();
	PenSize( 2, 2 );
	SetRect( &r, targetH, targetV, targetH+16, targetV+16 );
	FrameRect( &r );
	
	MoveTo( r.left+4, r.top+12 );
	DrawChar( (char)(target + '0') );
}

static DrawTime()
{
	Rect r;
	
	SetRect( &r, 480, 324, 510, 340 );
	
	NumBox( &r, (TickCount() - timer) / 60 );
}

static DrawTitle()
{
	PenSize( 2, 2 );
	MoveTo( 0, 320 );
	Line( 512, 0 );
	MoveTo( 10, 336 );
	DrawString("\pLightspeedC Pongerang by Steve Capps");	
}

static InitBall()
{
	offscreen.baseAddr = (QDPtr)&bits[0];
	offscreen.rowBytes = 2;
	SetRect( &offscreen.bounds, 0, 0, 16, 16 );
	
	StuffHex( (Ptr)offscreen.baseAddr,"\p07E01FF83FFC7FFE73CEE187E187F3CFFFFFDFFBEFF767E6700E3C3C1FF807E0");
}

static NewBumper( mh, mv )
int mh, mv;
{
	int newX, newY, newVal;
	
	if (bumper[ballX][ballY] != 0) return;

	newX = ballX;
	newY = ballY;
	newVal = 0;
	
	if ((dv < 0) && (newY > 0))
	{											/* going up */
		if (mh > hpos) { newY--; newVal = -1; }
		if (mh < hpos) { newY--; newVal =  1; }
	}
	
	if ((dv > 0) && (newY < 19))
	{											/* going down */
		if (mh > hpos) { newY++; newVal =  1; }
		if (mh < hpos) { newY++; newVal = -1; }
	}
	
	if ((dh < 0) && (newX > 0))
	{											/* going left */
		if (mv > vpos) { newX--; newVal = -1; }
		if (mv < vpos) { newX--; newVal =  1; }
	}
	
	if ((dh > 0) && (newX < 31))
	{											/* going right */
		if (mv > vpos) { newX++; newVal =  1; }
		if (mv < vpos) { newX++; newVal = -1; }
	}
	
	if (newVal != 0)
	{
		bumper[newX][newY] = newVal;
		DrawBumper( newX, newY );
	}
}
					

static NewGame()
{
	Rect r;
	register int i,j;
	
	r = thePort->portRect;
	r.bottom = 320;
	EraseRect( &r );
	
	hpos = Rand16( 32 );
	vpos = Rand16( 20 );

	target = 9;
	NewTarget();

	DrawBall();
	DrawTarget();
	
	timer = TickCount();
	
	for (i=0; i<32; i++) for (j=0; j<20; j++) bumper[i][j] = 0;
		
	SetRect( &r, 430, 324, 480, 340 );
	if (bestTime < 9999) NumBox( &r, bestTime );
	
	FlushEvents( -1, 0 );
}

static NewTarget()
{
	Rect r;
	
	SetRect( &r, targetH, targetV, targetH+16, targetV+16 );
	EraseRect( &r );
	
	targetH = Rand16( 32 );
	targetV = Rand16( 20 );
	
	DrawTarget();
}

static NumBox( r, n )
Rect *r;
long n;
{
	Str255 str;
	
	EraseRect( r );
	
	MoveTo( r->left+4, r->top+12 );
   
	NumToString( n, str);
	DrawString(str);
}

static int Rand16( x )
int x;
{
	int y;

	y = Random() % x;
	if (y < 0) y = -y;
	
	return(y * 16);
}

static Zoomer( from, to )
Rect *from, *to;
{
	register int i, j;
	Rect r1, r2, r3, r4;
	int w1, h1, w2, h2, w3, h3, w4, h4;
	
	SetRect( &r4, 0, 0, 0, 0 );
	r3 = r4; r2 = r3; r1 = r2;
	w1 = 0; w2 = 0; w3 = 0; w4 = 0;
	h1 = 0; h2 = 0; h3 = 0; h4 = 0;
		
	PenNormal();
	PenMode( patXor );
	
	for (j=0; j<40; j+=8)
	{
		for (i=0; i<8; i++)
		{
		 	if ((j==32) && (i > 5)) break;

			MoveTo( r4.left, r4.top + h4 );		/* drop old one */
			LineTo( r4.left + w4, r4.bottom );
			LineTo( r4.right, r4.bottom - h4 );
			LineTo( r4.right - w4, r4.top );
			LineTo( r4.left, r4.top + h4 );

			r4 = r3; r3 = r2; r2 = r1;
			w4 = w3; w3 = w2; w2 = w1;
			h4 = h3; h3 = h2; h2 = h1;
			
			if (j < 32)
			{
				w1 = i * (r1.right - r1.left) / 8;
				h1 = i * (r1.bottom - r1.top) / 8;
	
				r1.top = from->top + (j+i)*(to->top - from->top) / 32;
				r1.left = from->left + (j+i)*(to->left - from->left) / 32;
				r1.bottom = from->bottom + (j+i)*(to->bottom - from->bottom) / 32;
				r1.right = from->right + (j+i)*(to->right - from->right) / 32;

				MoveTo( r1.left, r1.top + h1 );		/* add new one */
				LineTo( r1.left + w1, r1.bottom );
				LineTo( r1.right, r1.bottom - h1 );
				LineTo( r1.right - w1, r1.top );
				LineTo( r1.left, r1.top + h1 );
		
			} /* skip new ones */
		} /* inner loop */
	} /* outer loop */
}
