// Simple Carbon port of the original Pongerang demo.
// Plan: To port this to TransSkel 5 and QDCG.

{$mode macpas}
program Pongerang;
uses
	MacOSAll;

const speed = 8;			// must be a power of 2 */

var
	hpos,					// ball h position */
	vpos: Longint; 				// ball v position */
	dh: Longint = speed;		// ball delta h */
	dv: Longint = 0;			// ball delta v */
	width: Longint = 16;				// ball width */
	height: Longint = 16;			// ball height */
	ballX,					// ball slot # */
	ballY: Longint;					// ball slot # */

	targetH,			// target h position */
	targetV, 			// target v position */
	target: Longint;
	
	bumper: array[0..31, 0..19] of Longint;		// slots for bouncers */

	done: Boolean;		// true when games over */

	ballTime,
	timer: Longint;
	bestTime: Longint = 9999;

	offscreen: BitMap;
	bits: array[0..127] of Longint;
	
	thePort: GrafPtr;

// Modified to work better under MultiFinder.
//   To be precise, it now uses a window, not just the window Mgr port.
//   The window centers on screenBits (main screen) */

var
	wind: WindowPtr;

procedure init_window;
var
//	port: GrafPtr;
	theRect: Rect;
	screenBits: BitMap;
begin
//	InitGraf(&thePort);
//	InitWindows();

//	GetWMgrPort(&port);
//	SetPort(port);
	SetRect(theRect, 0, 0, 512, 342);

	wind := NewWindow (nil, theRect, '', false, 8, WindowPtr(-1), false, 0);
	MoveWindow(wind, 0, 20, true);
	
	GetQDGlobalsScreenBits(screenBits);
	MoveWindow(wind, (screenBits.bounds.right - 512) div 2,
					 (screenBits.bounds.bottom - 322) div 2, true);
	ShowWindow(wind);
	SetPortWindowPort(wind);
	thePort := GetWindowPort(wind);

	TextSize(12);
	TextFont(5);
	
//	ClipRect(&theRect);
	EraseRect(theRect);
	HideCursor();
end;


procedure DrawBall;
var
	r: Rect;
begin	
	SetRect( r, hpos, vpos, hpos+16, vpos+16 );
	CopyBits( offscreen, GetPortBitMapForCopyBits(GetWindowPort(wind))^, offscreen.bounds, r, srcXor, nil );
end;

procedure DrawTarget;
var
	r: Rect;
begin
	PenNormal();
	PenSize( 2, 2 );
	SetRect( r, targetH, targetV, targetH+16, targetV+16 );
	FrameRect( r );
	
	MoveTo( r.left+4, r.top+12 );
	DrawChar( char(target + Ord('0')) );
end;

function Rand16( x: Integer ): Integer;
var
	y: Longint;
begin
	y := Random() mod x;
	if y < 0 then y := -y;
	
	return(y * 16);
end;

procedure NewTarget;
var
	r: Rect;
begin
	SetRect( r, targetH, targetV, targetH+16, targetV+16 );
	EraseRect( r );
	
	targetH := Rand16( 32 );
	targetV := Rand16( 20 );
	
	DrawTarget();
end;

procedure Zoomer(from, toRect: Rect);
var
	i, j: Longint; // register
	r1, r2, r3, r4: Rect;
	w1, h1, w2, h2, w3, h3, w4, h4: Longint;
begin
	SetRect( r4, 0, 0, 0, 0 );
	r3 := r4; r2 := r3; r1 := r2;
	w1 := 0; w2 := 0; w3 := 0; w4 := 0;
	h1 := 0; h2 := 0; h3 := 0; h4 := 0;
	
	PenNormal();
	PenMode( patXor );
	
//	for j=0; j<40; j+=8)
	j := 0;
	while j < 40 do
	begin
		for i := 0 to 7 do
		begin
		 	if ((j=32) and (i > 5)) then cycle; // break

			MoveTo( r4.left, r4.top + h4 );		// drop old one */
			LineTo( r4.left + w4, r4.bottom );
			LineTo( r4.right, r4.bottom - h4 );
			LineTo( r4.right - w4, r4.top );
			LineTo( r4.left, r4.top + h4 );

			r4 := r3; r3 := r2; r2 := r1;
			w4 := w3; w3 := w2; w2 := w1;
			h4 := h3; h3 := h2; h2 := h1;
			
			if (j < 32) then
			begin
				w1 := i * (r1.right - r1.left) div 8;
				h1 := i * (r1.bottom - r1.top) div 8;
	
				r1.top := from.top + (j+i)*(toRect.top - from.top) div 32;
				r1.left := from.left + (j+i)*(toRect.left - from.left) div 32;
				r1.bottom := from.bottom + (j+i)*(toRect.bottom - from.bottom) div 32;
				r1.right := from.right + (j+i)*(toRect.right - from.right) div 32;

				MoveTo( r1.left, r1.top + h1 );		// add new one */
				LineTo( r1.left + w1, r1.bottom );
				LineTo( r1.right, r1.bottom - h1 );
				LineTo( r1.right - w1, r1.top );
				LineTo( r1.left, r1.top + h1 );
		
			end; // skip new ones */
		end; // inner loop */
		j += 8;
	end; // outer loop */
end;

procedure NumBox( r: Rect; n: Longint);
var
	str: Str255;
begin
	EraseRect( r );
	
	MoveTo( r.left + 4, r.top + 12 );
	
	NumToString( n, str);
	DrawString(str);
end;

procedure NewGame;
var
	r: Rect;
	i,j: Longint;
	portRect: Rect;
begin
	GetPortBounds(thePort, portRect);
	r := portRect;
	r.bottom := 320;
	EraseRect( r );
	
	hpos := Rand16( 32 );
	vpos := Rand16( 20 );

	target := 9;
	NewTarget();

	DrawBall();
	DrawTarget();
	
	timer := TickCount();
	
	for i:=0 to 31 do
		for j:=0 to 19 do
			bumper[i][j] := 0;
		
	SetRect( r, 430, 324, 480, 340 );
	if (bestTime < 9999) then
		NumBox( r, bestTime );
	
	FlushEvents( -1, 0 );
end;

procedure BallMove;
var
	r: Rect;
	x, i: Longint;
	portRect: Rect;
begin	
	SetRect(r, targetH, targetV, targetH+16, targetV+16 );
	
	x := TickCount();
	while x = TickCount() do begin end;
	if (vpos < 80) then
		for i:=1 to 255 do begin end; // ???? Tappat nt hr?

	DrawBall();
	hpos += dh;
	vpos += dv;
	
	if ((hpos >= 512) or (hpos < 0)) then
	begin
		hpos += -dh;
		dh := -dh;
	end;
	if ((vpos >= 320) or (vpos < 0)) then
	begin
		vpos += -dv;
		dv := -dv;
	end;
	
	if ((hpos = targetH) and (vpos = targetV)) then
	begin
		SysBeep( 2 );
		target -= 1;
		if (target > 0) then
		begin
			NewTarget();
		end
		else
		begin
			x := (TickCount() - timer) div 60;
			if (x < bestTime) then
				bestTime := x;
			
			GetPortBounds(thePort, portRect);
			Zoomer(r, portRect);
			NewGame();
			return;
		end;
	end;
	
	DrawBall();
end;

procedure DrawBumper(x, y: Longint);
var
	r: Rect;
begin
	PenSize( 2, 2 );
	SetRect( r, x*16, y*16, x*16+16, y*16+16 );
	EraseRect( r );
	
	if (bumper[x][y] > 0) then
	begin
		MoveTo(r.left, r.top);
		Line( 14, 14 );
	end;
	if (bumper[x][y] < 0) then
	begin
		MoveTo(r.left, r.bottom-2);
		Line( 14, -14 );
	end;
end;

procedure DrawTime;
var
	r: Rect;
begin
	SetRect( r, 475, 324, 510, 340 );
	
	NumBox( r, (TickCount() - timer) div 60 );
end;

procedure DrawTitle;
begin
	PenSize( 2, 2 );
	MoveTo( 0, 320 );
	Line( 512, 0 );
	MoveTo( 10, 336 );
	DrawString('LightspeedC Pongerang by Steve Capps, to FPC by IR');
// This should be true some time
//	MoveTo( 10, 356 );
//	DrawString('To FPC and TransSkel5 by Ingemar Ragnemalm');
end;

procedure InitBall;
begin
	offscreen.baseAddr := (*QDPtr*)@bits[0];
	offscreen.rowBytes := 2;
	SetRect( offscreen.bounds, 0, 0, 16, 16 );
	
	StuffHex( offscreen.baseAddr,'07E01FF83FFC7FFE73CEE187E187F3CFFFFFDFFBEFF767E6700E3C3C1FF807E0');
end;

procedure NewBumper( mh, mv: Longint);
var
	newX, newY, newVal: Longint;
begin
	if (bumper[ballX][ballY] <> 0) then return;

	newX := ballX;
	newY := ballY;
	newVal := 0;
	
	if ((dv < 0) and (newY > 0)) then
	begin											// going up */
		if (mh > hpos) then
		begin newY-=1; newVal := -1;end;
		if (mh < hpos) then
		begin newY-=1; newVal :=  1;end;
	end;
	
	if ((dv > 0) and (newY < 19)) then
	begin											// going down */
		if (mh > hpos) then
		begin newY+=1; newVal :=  1;end;
		if (mh < hpos) then
		begin newY+=1; newVal := -1;end;
	end;
	
	if ((dh < 0) and (newX > 0)) then
	begin											// going left */
		if (mv > vpos) then
		begin newX-=1; newVal := -1;end;
		if (mv < vpos) then
		begin newX-=1; newVal :=  1;end;
	end;
	
	if ((dh > 0) and (newX < 31)) then
	begin											// going right */
		if (mv > vpos) then
		begin newX+=1; newVal :=  1;end;
		if (mv < vpos) then
		begin newX+=1; newVal := -1;end;
	end;
	
	if (newVal <> 0) then
	begin
		bumper[newX][newY] := newVal;
		DrawBumper( newX, newY );
	end;
end;

//procedure PlayPongerang();

var
	evt: EventRecord;
	spot: Longint;
begin	
	done := false;
	
	init_window();
	DrawTitle();

// Vad r detta fr nonsens? Klumpig randomisering?
	spot := TickCount() mod 1000;
//	while (spot-- > 0) then
//		Random();
	
	InitCursor();
	
	InitBall();
	
	NewGame();
	
	while not done do
	begin
		ballX := hpos div 16;		// round up in current direction */
		ballY := vpos div 16;

		spot := bumper[ballX][ballY];

		// only check events and turns on even slots */
		if (((hpos mod 16) = 0) and ((vpos mod 16) = 0)) then
		begin
			if (GetNextEvent(-1, evt )) then
			begin // was GetNextEvent
				case (evt.what) of
				keyDown:
						done := true;
				mouseDown:
					begin
						GlobalToLocal(evt.where);
						NewBumper(evt.where.h, evt.where.v );
					end;
				end; // end switch */
			end; // getnextevent */
		
		
			if (dv < 0) then
			begin
				if (spot > 0) then begin dh := -speed; dv := 0;end;
				if (spot < 0) then begin dh :=  speed; dv := 0;end;
			end
			else if (dv > 0) then
			begin
				if (spot > 0) then
				begin dh :=  speed; dv := 0;end;
				if (spot < 0) then
				begin dh := -speed; dv := 0;end;
			end
			else if (dh < 0) then
			begin
				if (spot > 0) then begin dh := 0; dv := -speed;end;
				if (spot < 0) then begin dh := 0; dv :=  speed;end;
			end
			else if (dh > 0) then
			begin
				if (spot > 0) then begin dh := 0; dv :=  speed;end;
				if (spot < 0) then begin dh := 0; dv := -speed;end;
			end;
		end; // end of even check */
		
		BallMove();
		
		DrawTime();
	end; // main loop */
	
	DisposeWindow(FrontWindow());
end.
